Bug 1018390 - gtk3: Net/FallbackIconTheme regression/non-functional
gtk3: Net/FallbackIconTheme regression/non-functional
Status: CLOSED ERRATA
Product: Fedora
Classification: Fedora
Component: gtk3 (Show other bugs)
20
Unspecified Unspecified
unspecified Severity unspecified
: ---
: ---
Assigned To: Matthias Clasen
Fedora Extras Quality Assurance
:
Depends On:
Blocks: F20Target-kde
  Show dependency treegraph
 
Reported: 2013-10-11 16:34 EDT by Rex Dieter
Modified: 2013-11-10 01:43 EST (History)
5 users (show)

See Also:
Fixed In Version: gtk3-3.10.2-2.fc20
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2013-11-10 01:43:37 EST
Type: Bug
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)
screenshot demonstrating missing toolbar icons (25.22 KB, image/png)
2013-10-11 16:37 EDT, Rex Dieter
no flags Details


External Trackers
Tracker ID Priority Status Summary Last Updated
GNOME Desktop 708163 None None None Never

  None (edit)
Description Rex Dieter 2013-10-11 16:34:39 EDT
gtk3 apps on kde are often without proper icons on f20, I *suspect* something changed or not working as expected with Net/FallbackIconTheme 

In particular, xsettings-kde, sets Net/FallbackIconTheme to gnome.

evince, for example, doesn't show any of it's usual symbolic toolbar icons when using kde's default oxygen-icons.

If I set icon theme to Fedora/gnome or modify oxygen/index.theme
Inherits=gnome,hicolor

then it works again.
Comment 1 Rex Dieter 2013-10-11 16:37:19 EDT
Created attachment 811388 [details]
screenshot demonstrating missing toolbar icons
Comment 2 Rex Dieter 2013-10-11 16:42:05 EDT
Oh, eep, googling finds:

http://osdir.com/ml/commits.gnome/2013-06/msg06019.html

"Deprecate and ignore gtk-fallback-icon-theme
The standard icon themes have built in fallbacks."

A little unfortunate, but I suppose we can patch oxygen with the workaround mentioned in comment #1

Unless, there's some other better suggestion?
Comment 3 Kevin Kofler 2013-10-11 16:50:20 EDT
Inheriting the GNOME theme in Oxygen makes no sense whatsoever. The same way the implied fallback for KDE apps is Oxygen, the implied fallback for GNOME/GTK+ apps needs to be the GNOME theme. KDE apps should not fall back to the GNOME theme, that just doesn't make sense.

In addition, it wouldn't fix the problem for people using themes inheriting neither Oxygen nor GNOME. It doesn't make sense to expect all of them to inherit the GNOME theme nor to provide the non-freedesktop.org symbolic icons.

Net/FallbackIconTheme is REQUIRED for GTK+ to work properly with any icon theme that does not inherit the GNOME theme. The freedesktop.org icon theme specifies nowhere that themes must inherit the GNOME theme nor that they have to provide the same nonstandard icons. The upstream patch breaks all the non-GNOME freedesktop.org-compliant icon themes for GTK+ apps and needs to be reverted.
Comment 4 Kevin Kofler 2013-10-11 16:52:25 EDT
Oh, and if you really want to get rid of the setting, why not just hardcode it to "gnome" instead of dropping the functionality completely? That's what everyone (even xsettings-kde) sets Net/FallbackIconTheme to anyway.
Comment 5 Rex Dieter 2013-10-11 16:55:27 EDT
I would tend to agree with that assessment, in particular, I don't think it unreasonable to ask that gtk3 apps to implicitly fallback to gnome-icon-theme somehow.

I don't care about the implementation details, whether that means re-implementing Net/FallbackIconTheme or some hard-coded fallback in gtk3, or some other even better idea.
Comment 6 Kamil Páral 2013-10-21 07:08:42 EDT
This might be related (already partially linked in comment 2):

https://mail.gnome.org/archives/gtk-devel-list/2013-July/msg00000.html
Comment 7 Rex Dieter 2013-10-21 07:58:59 EDT
That is a separate issue (and easier to identify and fix, applications that use that deprecated stock icons api fail to build)
Comment 8 Matthias Clasen 2013-10-21 08:21:41 EDT
Should be fixed in 3.10.2 with

https://git.gnome.org/browse/gtk+/commit/?h=gtk-3-10&id=d25ee710715c60801b29289c4a0ee85fb337579c
Comment 9 Rex Dieter 2013-10-21 08:55:13 EDT
Thanks.
Comment 10 Rex Dieter 2013-10-21 11:31:05 EDT
Testing with gtk3-3.10.2-1.fc20.x86_64 , I'm still seeing what appears to be a fair number of missing icons in evince, per the screenshot posted in comment #1
Comment 11 Matthias Clasen 2013-10-21 12:28:53 EDT
We'll have to look into how those buttons are constructed - maybe they are not doing generic fallback for icon names.
Comment 12 Matthias Clasen 2013-10-21 12:54:18 EDT
Does oxygen not ship standard icons like go-up, go-down ?
Comment 13 Rex Dieter 2013-10-21 13:09:10 EDT
It does,

$ rpm -ql oxygen-icon-theme | grep -e 'go-[ud]'
/usr/share/icons/oxygen/128x128/actions/go-down.png
/usr/share/icons/oxygen/128x128/actions/go-up.png
/usr/share/icons/oxygen/16x16/actions/go-down-search.png
/usr/share/icons/oxygen/16x16/actions/go-down.png
/usr/share/icons/oxygen/16x16/actions/go-up-search.png
/usr/share/icons/oxygen/16x16/actions/go-up.png
/usr/share/icons/oxygen/22x22/actions/go-down-search.png
/usr/share/icons/oxygen/22x22/actions/go-down.png
/usr/share/icons/oxygen/22x22/actions/go-up-search.png
/usr/share/icons/oxygen/22x22/actions/go-up.png
/usr/share/icons/oxygen/32x32/actions/go-down-search.png
/usr/share/icons/oxygen/32x32/actions/go-down.png
/usr/share/icons/oxygen/32x32/actions/go-up-search.png
/usr/share/icons/oxygen/32x32/actions/go-up.png
/usr/share/icons/oxygen/48x48/actions/go-down-search.png
/usr/share/icons/oxygen/48x48/actions/go-down.png
/usr/share/icons/oxygen/48x48/actions/go-up-search.png
/usr/share/icons/oxygen/48x48/actions/go-up.png
/usr/share/icons/oxygen/64x64/actions/go-down.png
/usr/share/icons/oxygen/64x64/actions/go-up.png
Comment 14 Fedora Update System 2013-10-21 13:55:40 EDT
gtk3-3.10.2-2.fc20 has been submitted as an update for Fedora 20.
https://admin.fedoraproject.org/updates/gtk3-3.10.2-2.fc20
Comment 15 Rex Dieter 2013-10-21 14:40:01 EDT
Thanks, confirmed good.
Comment 16 Fedora Update System 2013-10-22 14:54:09 EDT
Package gtk3-3.10.2-2.fc20:
* should fix your issue,
* was pushed to the Fedora 20 testing repository,
* should be available at your local mirror within two days.
Update it with:
# su -c 'yum update --enablerepo=updates-testing gtk3-3.10.2-2.fc20'
as soon as you are able to.
Please go to the following url:
https://admin.fedoraproject.org/updates/FEDORA-2013-19701/gtk3-3.10.2-2.fc20
then log in and leave karma (feedback).
Comment 17 Fedora Update System 2013-11-10 01:43:37 EST
gtk3-3.10.2-2.fc20 has been pushed to the Fedora 20 stable repository.  If problems still persist, please make note of it in this bug report.

Note You need to log in before you can comment on or make changes to this bug.